package com.rp.util;

import java.lang.reflect.*;
import java.util.*;

/**
 *
 * @author  Dan Richardson
 * @version 1.0, 09/2002
 */
 
public final class ReflectionUtil
{
	public static Object getMethodValue (Object obj, String methodName, Class[] paramTypes, Object[] paramValues) throws InvocationTargetException, NoSuchMethodException,
													IllegalAccessException
	{
		Class c = obj.getClass();
		Method method = c.getMethod(methodName, paramTypes);
		Object ret = method.invoke (obj, paramValues);	
		return ret;
	}

	public static Object getMethodValueNoParams (Object obj, String methodName) throws InvocationTargetException, NoSuchMethodException,
													IllegalAccessException
	{
		Class c = obj.getClass();
		Method method = c.getMethod(methodName, new Class[0]);
		Object ret = method.invoke(obj, new Object[0]);		
		return ret;
	}
	
	public static Map getMethodNameValuesNoParams (Object obj, String methodString) throws InvocationTargetException, NoSuchMethodException,
													IllegalAccessException
	{
		Map retMap = new HashMap();
		Class c = obj.getClass();
		Method[] method = c.getMethods();
		int size = method.length;
		
		for (int i = 0; i < size; i++)
		{
			String name = method[i].getName();
			if (name.indexOf(methodString) > -1)
			{
				retMap.put (name, method[i].invoke(obj, new Object[0]));	
			}
		}
		return retMap;
	}	
	
	public static String getMethodNames (Object obj, String lineFeed)
	{
		Class c = obj.getClass();
		Method[] method = c.getMethods();
		int size = method.length;
		StringBuffer sb = new StringBuffer(100);
		
		for (int i = 0; i < size; i++)
		{
			String name = method[i].getName();
			sb.append (name + lineFeed);
		}
		return sb.toString();
	}
}

