package com.rp.util.sort;

import com.rp.util.sort.ISort;
import com.rp.util.sort.SortException;
import com.rp.util.ReflectionUtil;
import java.util.Comparator;
import java.util.List;

public final class BubbleSort implements ISort
{
	
	public BubbleSort ()
	{}

	public void sort (int[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (int[] arr, int begin, int end)
	{	
		int temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1] > arr[j])
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (String[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (String[] arr, int begin, int end)
	{
 		String temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1].compareToIgnoreCase(arr[j]) > 0)
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (long[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (long[] arr, int begin, int end)
	{
 		long temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1] > arr[j])
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (short[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (short[] arr, int begin, int end)
	{
 		short temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1] > arr[j])
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (double[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (double[] arr, int begin, int end)
	{
 		double temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1] > arr[j])
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (float[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (float[] arr, int begin, int end)
	{
 		float temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1] > arr[j])
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (char[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (char[] arr, int begin, int end)
	{
 		char temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1] > arr[j])
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (byte[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (byte[] arr, int begin, int end)
	{
 		byte temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (arr[j-1] > arr[j])
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (Object[] arr, Comparator c, String methodName) throws SortException
	{
		sort (arr, c, methodName, new Class[0], new Object[0]);	
	}
	
	public void sort (Object[] arr, Comparator c, String methodName, Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		sort (arr, 0, arr.length-1, c, methodName, paramTypes, paramValues);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName)  
							throws SortException
	{
		sort (arr, begin, end, c, methodName, new Class[0], new Object[0]);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName, 
							Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		try
		{
			Object temp;
			for (int i = (end); i >= begin; i--)
			{
				for (int j = 1; j <= i; j++)
				{
					if (c.compare(ReflectionUtil.getMethodValue (arr[j-1], methodName, paramTypes, paramValues),
						ReflectionUtil.getMethodValue (arr[j], methodName, paramTypes, paramValues)) > 0)
					{
						temp = arr[j-1];
						arr[j-1] = arr[j];
						arr[j] = temp;
					}
				}
			}
		}
		catch (Exception e)
		{
			throw new SortException (e);	
		}
	}
	
	public void sort (Object[] arr, Comparator c)
	{
		sort (arr, 0, arr.length-1, c);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c)
	{
		Object temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (c.compare(arr[j-1], arr[j]) > 0)
				{
					temp = arr[j-1];
					arr[j-1] = arr[j];
					arr[j] = temp;
				}
			}
		}
	}
	
	public void sort (List arr, Comparator c)
	{
		sort (arr, 0, arr.size()-1, c);	
	}
	
	public void sort (List arr, int begin, int end, Comparator c)
	{
		Object temp;
		for (int i = (end); i >= begin; i--)
		{
			for (int j = 1; j <= i; j++)
			{
				if (c.compare(arr.get(j-1), arr.get(j)) > 0)
				{
					temp = arr.get(j-1);
					arr.set(j-1, arr.get(j));
					arr.set(j, temp);	
				}	
			}	
		}
	}
}