package com.rp.util.sort;

import com.rp.util.sort.ISort;
import com.rp.util.sort.SortException;
import com.rp.util.ReflectionUtil;
import java.util.Comparator;
import java.util.List;

public final class QuickInsertionSort implements ISort
{
	public final static int k = 10;
	private InsertionSort is = null;
	
	public QuickInsertionSort ()
	{
		is = new InsertionSort();	
	}
	
	public void sort (int[] arr)
	{
		sort (arr, 0, arr.length-1);
	}

	public void sort (int[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			int middle = arr[(begin + end) / 2];
			int temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	public void sort (String[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (String[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			String middle = arr[(begin + end) / 2];
			String temp;
			while (low <= high)
			{
				while (low < end && arr[low].compareToIgnoreCase(middle) < 0)
				{
					low++;
				}
				while (high > begin && arr[high].compareToIgnoreCase(middle) > 0)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	public void sort (long[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (long[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			long middle = arr[(begin + end) / 2];
			long temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}
	
	public void sort (short[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (short[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			short middle = arr[(begin + end) / 2];
			short temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	public void sort (double[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (double[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			double middle = arr[(begin + end) / 2];
			double temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	public void sort (float[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (float[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			float middle = arr[(begin + end) / 2];
			float temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	public void sort (char[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (char[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			char middle = arr[(begin + end) / 2];
			char temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	public void sort (byte[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (byte[] arr, int begin, int end)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end);
			return;	
		}
		
		if (end > begin)
		{
			int low = begin;
			int high = end;
			byte middle = arr[(begin + end) / 2];
			byte temp;
			while (low <= high)
			{
				while (low < end && arr[low] < middle)
				{
					low++;
				}
				while (high > begin && arr[high] > middle)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high);	
			}
			if (low < end)
			{
				sort (arr, low, end);
			}
		}
	}

	public void sort (Object[] arr, Comparator c, String methodName) throws SortException
	{
		sort (arr, c, methodName, new Class[0], new Object[0]);	
	}
	
	public void sort (Object[] arr, Comparator c, String methodName, Class[] paramTypes, Object[] paramValues)
						 throws SortException
	{
		sort (arr, 0, arr.length-1, c, methodName, paramTypes, paramValues);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName) 
							throws SortException
	{
		sort (arr, begin, end, c, methodName, new Class[0], new Object[0]);
	}

	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName, Class[] paramTypes,
								Object[] paramValues) throws SortException
	{
		try
		{
			if ( (end - begin) <= k)
			{
				is.sort (arr, begin, end, c, methodName, paramTypes, paramValues);
				return;	
			}
		
			if (end > begin)
			{
				int low = begin;
				int high = end;
				Object middle = ReflectionUtil.getMethodValue(arr[(begin + end) / 2], methodName, paramTypes, paramValues);
				Object temp;
				while (low <= high)
				{
					while (low < end && c.compare(ReflectionUtil.getMethodValue(arr[low], methodName, paramTypes, paramValues),
							 middle) < 0)
					{
						low++;
					}
					while (high > begin && c.compare(ReflectionUtil.getMethodValue (arr[high], methodName, paramTypes, paramValues), 
							 middle) > 0)
					{
						high--;	
					}
					if (low <= high)
					{
						temp = arr[low];
						arr[low] = arr[high];
						arr[high] = temp;
						low++;
						high--;	
					}
				}
				if (begin < high)
				{
					sort (arr, begin, high, c, methodName, paramTypes, paramValues);	
				}
				if (low < end)
				{
					sort (arr, low, end, c, methodName, paramTypes, paramValues);
				}
			}
		}
		catch (Exception e)
		{
			throw new SortException (e);	
		}
	}
	
	public void sort (Object[] arr, Comparator c)
	{
		sort (arr, 0, arr.length-1, c);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end, c);
			return;	
		}
	
		if (end > begin)
		{
			int low = begin;
			int high = end;
			Object middle = arr[(begin + end) / 2];
			Object temp = arr[low];
			arr[low] = arr[high];
			arr[high] = temp;
			while (low <= high)
			{
				while (low < end && c.compare(arr[low], middle) < 0)
				{
					low++;
				}
				while (high > begin && c.compare(arr[high], middle) > 0)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr[low];
					arr[low] = arr[high];
					arr[high] = temp;
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high, c);	
			}
			if (low < end)
			{
				sort (arr, low, end, c);
			}
		}
	}
	
	public void sort (List arr, Comparator c)
	{
		sort (arr, 0, arr.size()-1, c);
	}
	
	public void sort (List arr, int begin, int end, Comparator c)
	{
		if ( (end - begin) <= k)
		{
			is.sort (arr, begin, end, c);
			return;	
		}
	
		if (end > begin)
		{
			int low = begin;
			int high = end;
			Object middle = arr.get((begin + end) / 2);
			Object temp;
			while (low <= high)
			{
				while (low < end && c.compare(arr.get(low), middle) < 0)
				{
					low++;
				}
				while (high > begin && c.compare(arr.get(high), middle) > 0)
				{
					high--;	
				}
				if (low <= high)
				{
					temp = arr.get(low);
					arr.set(low, arr.get(high));
					arr.set(high, temp);
					low++;
					high--;	
				}
			}
			if (begin < high)
			{
				sort (arr, begin, high, c);	
			}
			if (low < end)
			{
				sort (arr, low, end, c);
			}
		}
	}
}