package test.sort;

import com.rp.util.test.RandomArrayGenerator;
import com.rp.util.sort.*;
import test.util.ArrayPrint;
import test.sort.IObject;
import test.sort.IObjectCompare;
import com.rp.util.sort.compare.IntegerComparator;
import com.rp.util.sort.*;

import java.util.List;
import java.util.ArrayList;

public class SortTest
{
	private ISort sort = null;
	private RandomArrayGenerator rd = null;
	private ArrayPrint arrayPrint = null;
	
	public SortTest (ISort sort)
	{
		this.sort = sort;	
		this.arrayPrint = new ArrayPrint();
	}
	
	public void sort (String type, int count)
	{
		if (type.equals("int"))
		{
			int[] arr = rd.getInt(count);
			int[] arr2 = new int[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			int[] arr3 = new int[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
		
		if (type.equals("String"))
		{
			String[] arr = rd.getString(count, 5);
			String[] arr2 = new String[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			String[] arr3 = new String[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
		
		if (type.equals("long"))
		{
			long[] arr = rd.getLong(count);
			long[] arr2 = new long[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			long[] arr3 = new long[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
		
		if (type.equals("short"))
		{
			short[] arr = rd.getShort(count);
			short[] arr2 = new short[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			short[] arr3 = new short[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
			
		if (type.equals("double"))
		{
			double[] arr = rd.getDouble(count);
			double[] arr2 = new double[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			double[] arr3 = new double[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
		
		if (type.equals("float"))
		{
			float[] arr = rd.getFloat(count);
			float[] arr2 = new float[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			float[] arr3 = new float[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
		
		if (type.equals("char"))
		{
			char[] arr = rd.getChar(count);
			char[] arr2 = new char[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			char[] arr3 = new char[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
		
		if (type.equals("byte"))
		{
			byte[] arr = rd.getByte(count);
			byte[] arr2 = new byte[count];
			System.arraycopy(arr, 0, arr2, 0, count);
			sort.sort(arr);
			sort.sort(arr2, 1, count-2);
			byte[] arr3 = new byte[count-3];
			System.arraycopy(arr2, 1, arr3, 0, count-3);
			
			System.out.println (sort.getClass().getName());
			System.out.println (type);
			System.out.println ("SORT FROM 0 TO " +count);
			arrayPrint.print(arr);	
			System.out.println ("SORT FROM 1 TO " +(count-2));
			arrayPrint.print(arr3);	
			System.out.println ("");
		}
		
		if (type.equals("Object"))
		{
			try
			{
				int[] intVals = RandomArrayGenerator.getInt (count);
				IntegerComparator icomp = new IntegerComparator();
				IObject[] arr = new IObject[count];		
				IObject[] arr2 = new IObject[count];
				for (int i = 0; i < count; i++)
				{	
					IObject ione = new IObject();
					ione.setData (new Integer(intVals[i]));
					arr[i] = ione;
				}
				System.arraycopy(arr, 0, arr2, 0, count);
				sort.sort (arr, icomp, "getData");
				sort.sort (arr2, 1, count-2, icomp, "getData");
				IObject[] arr3 = new IObject[count-3];
				System.arraycopy(arr2, 1, arr3, 0, count-3);
				
				System.out.println (sort.getClass().getName());
				System.out.println (type);
				System.out.println ("SORT FROM 0 TO " +count);
				printObject (arr);
				System.out.println ("SORT FROM 1 TO " +(count-2));
				printObject (arr3);
				System.out.println ("");
			}
			catch (Exception e)
			{
				System.out.println ("EXCEPTION: " +e.toString());
			}	
		}
		
		if (type.equals("ObjectC"))
		{
			try
			{
				int[] intVals = RandomArrayGenerator.getInt (count);
				IObject[] arr = new IObject[count];		
				IObject[] arr2 = new IObject[count];
				IObjectCompare io = new IObjectCompare();
				for (int i = 0; i < count; i++)
				{	
					IObject ione = new IObject();
					ione.setData (new Integer(intVals[i]));
					arr[i] = ione;
				}
				System.arraycopy(arr, 0, arr2, 0, count);
				sort.sort (arr, io);
				sort.sort (arr2, 1, count-2, io);
				IObject[] arr3 = new IObject[count-3];
				System.arraycopy(arr2, 1, arr3, 0, count-3);
				
				System.out.println (sort.getClass().getName());
				System.out.println (type);
				System.out.println ("SORT FROM 0 TO " +count);
				printObject (arr);
				System.out.println ("SORT FROM 1 TO " +(count-2));
				printObject (arr3);
				System.out.println ("");
			}
			catch (Exception e)
			{
				System.out.println ("EXCEPTION: " +e.toString());
			}	
		}
		
		if (type.equals("List"))
		{
			try
			{
				int[] intVals = RandomArrayGenerator.getInt (count);
				List arr = new ArrayList (count);
				List arr2 = new ArrayList (count);
				List arr3 = new ArrayList (count-3);
				IObjectCompare io = new IObjectCompare();
				for (int i = 0; i < count; i++)
				{
					IObject ione = new IObject();
					ione.setData (new Integer(intVals[i]));
					arr.add (ione);	
				}
				for (int i = 0; i < count; i++)
				{
					arr2.add (arr.get(i));	
				}
				
				sort.sort (arr, io);
				sort.sort (arr2, 1, count-2, io);
				
				for (int i = 1; i < count-2; i++)
				{
					arr3.add (arr2.get(i));	
				}
				
				System.out.println (sort.getClass().getName());
				System.out.println (type);
				System.out.println ("SORT FROM 0 TO " +count);
				printObject (arr);
				System.out.println ("SORT FROM 1 TO " +(count-2));
				printObject (arr3);
				System.out.println ("");
			}
			catch (Exception e)
			{
				System.out.println ("EXCEPTION: " +e.toString());
			}	
		}
	}
	
	public static void printObject (Object[] arr)
	{
		int len = arr.length;
		for (int i = 0; i < len; i++)
		{
			System.out.print (((IObject)arr[i]).getData() + ",");	
		}	
		System.out.println("");
	}
	
	public static void printObject (List arr)
	{
		int len = arr.size();
		for (int i = 0; i < len; i++)
		{
			System.out.print (((IObject)arr.get(i)).getData() + ",");	
		}	
		System.out.println("");
	}
}